#!/usr/bin/env python
# -*- coding: utf-8 -*-

# file      : fricorder.py
# project   : fricorder
# copyright : (C) 2013 by Claude Bulin
#
# This file is part of fricorder project
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; version 3.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA


import locale, os, sys
from fconfig import FConfig
from wind_main import wind_main
# init the foreign language
import Language_Init


# Ensure the openshot module directory is in the system path so relative 'import' statements work
base_path = os.path.dirname(os.path.abspath(__file__))
if sys.path.count(base_path) == 0:
	sys.path.insert(0, base_path)


if __name__ == '__main__':
	print( "")
	print( "!"+"-"*40)
	print( "! %s - %s" % (FConfig.__PACKAGE__,  FConfig.__VERSION__))
	print( "!"+"-"*3)
	print( "! Recording TV programs from the FreeBox" )
	print( "! Project from:" )
	print( "!   https://code.google.com/p/fricorder/" )
	print( "!   Copyright 2005-2008 - manatlan - Licence GPL2" )
	print( "!   http://fricorder.googlecode.com" )
	print( "!   http://manatlan.com" )
	print( "!"+"-"*3)
	print( "! %s" % FConfig.__AUTHOR__)
	print( "! http://www.xcfa.tuxfamily.org/" )
	print( "! Licence LGPL-3" )
	print( "!"+"-"*40)

	FConfig.print_FConfig()

	_ = Language_Init.Translator(FConfig).lang.gettext
	locale.setlocale(locale.LC_ALL, '')
	gui = wind_main()
	gui.run()

