#!/usr/bin/env python
# -*- coding: utf-8 -*-

# file      : wind_about.py
# project   : fricorder
# copyright : (C) 2013 by Claude Bulin
#
# This file is part of fricorder project
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; version 3.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA


import os

from SimpleGtkBuilderApp import SimpleGtkBuilderApp
from fconfig import FConfig
# init the foreign language
import Language_Init

class wind_about(SimpleGtkBuilderApp):

	def __init__(self, path="wind_about.glade", root="wind_about", domain="fricorder", form=None, project=None, selected_files=None, **kwargs):
		SimpleGtkBuilderApp.__init__(self, os.path.join(FConfig.DATADIR, path), root, domain, **kwargs)

		# Add language support
		_ = Language_Init.Translator(FConfig).lang.gettext
		self._ = _

		self.form = form
		self.project = project

		self.wind_about.set_title(_("A propos"))
		self.wind_about.show()

	def on_aboutdialog_fricorder_destroy_event(self, widget, data=None):
		self.wind_about.destroy()

	def on_aboutdialog_fricorder_delete_event(self, widget, data=None):
		self.wind_about.destroy()

	def on_aboutdialog_fricorder_response(self, widget, data=None):
		 self.wind_about.destroy()

