#!/usr/bin/env python
# -*- coding: utf-8 -*-

# file      : wind_main.py
# project   : fricorder
# copyright : (C) 2013 by Claude Bulin
#
#!/usr/bin/env python
# -*- coding: utf-8 -*-

# file      : wind_main.py
# project   : fricorder
# copyright : (C) 2013 by Claude Bulin
#
# This file is part of fricorder project
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; version 3.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA


import os, sys, subprocess
try:
    from gi.repository import Gtk, GObject
except:
    if os.path.isfile("/usr/bin/zenity") == True:
        command = 'zenity --info --text="You need at least python v3 to run fricorder" --title="Python Project Translating"'
        subprocess.call(command, shell=True)
    elif os.path.isfile("/usr/bin/vte") == True:
        command = "vte --command 'dialog --title \"Python Project Translating\" --msgbox \"\nYou need at least python v3 to run fricorder\" 12 50'"
        subprocess.call(command, shell=True)
    else:
        print('')
        print('Fricorder')
        print('')
        print('You need at least python v3 to run fricorder !')
        print('')
    exit(0)

import time
import datetime

from SimpleGtkBuilderApp import SimpleGtkBuilderApp
from fconfig import FConfig
from wind_chooser import wind_chooser
from wind_about import wind_about
import fbx
import common
import api
import messagebox
from prefs import Preferences
# init the foreign language
import Language_Init

class wind_main(SimpleGtkBuilderApp):

	def __init__(self, path="wind_main.glade", root="wind_main", domain="fricorder", form=None, project=None, selected_files=None, **kwargs):
		SimpleGtkBuilderApp.__init__(self, os.path.join(FConfig.DATADIR, path), root, domain, **kwargs)

		# Add language support
		_ = Language_Init.Translator(FConfig).lang.gettext
		self._ = _

		self.form = form
		self.project = project

		self.wind_main.set_title("%s in python3  - %s  - by xcfaudio" % (FConfig.__PACKAGE__, FConfig.__VERSION__))
		#time.sleep(0.0001)
		#while Gtk.events_pending():
			#Gtk.main_iteration()
			#time.sleep(0.0001)

		# Preferences: init
		self.Prefs = Preferences()
		self.Prefs.Preferences_read_file()

		# Preferences: size window
		win_width      = self.Prefs.Preferences_get_win_width()
		win_height     = self.Prefs.Preferences_get_win_height()
		main_win_pos_x = self.Prefs.Preferences_get_main_win_pos_x()
		main_win_pos_y = self.Prefs.Preferences_get_main_win_pos_y()
		self.wind_main.resize( win_width, win_height )
		self.wind_main.move( main_win_pos_x, main_win_pos_y )

		# init self.date
		self.date = datetime.datetime.now()

		# maj de la liste des chaines
		cell = Gtk.CellRendererText()
		self.cb_chaine.pack_start(cell, False)
		self.cb_chaine.add_attribute(cell, 'text',4)
		cell = Gtk.CellRendererText()
		self.cb_chaine.pack_start(cell, True)
		self.cb_chaine.add_attribute(cell, 'text',0)
		cell = Gtk.CellRendererText()
		self.cb_chaine.pack_start(cell, False)
		self.cb_chaine.add_attribute(cell, 'text',3)
		L = fbx.getStreams()
		m = Gtk.ListStore( str,str,str,str,str)
		m.clear()
		for num,chaine,url in L:
			chaineTV=None
			m.append( [chaine,common.normalize(chaine),url,chaineTV,"%d)"%num] )
		self.cb_chaine.set_model(m)
		self.cb_chaine.set_active( self.Prefs.Preferences_get_chaine_active() )

		# maj de la combobox des jours
		cell = Gtk.CellRendererText()
		self.cb_jour.pack_start(cell, True)
		self.cb_jour.add_attribute(cell, 'text',0)
		m=Gtk.ListStore( str, )
		m.clear()
		for num,jour in api.getJours(self.date,14):
			m.append( [common.affDate(jour),] )
		self.cb_jour.set_model(m)
		self.cb_jour.set_active( self.Prefs.Preferences_get_jour_actif() )

		# maj des spinbox heure de debut
		self.sb_heure.set_value( int(self.date.hour) )
		self.sb_min.set_value( self.date.minute )
		self.sb_time.set_value( self.Prefs.Preferences_get_sb_time() )

		# maj de la combobox quality
		cell = Gtk.CellRendererText()
		self.cb_quality.pack_start(cell, True)
		self.cb_quality.add_attribute(cell, 'text',0)
		m = Gtk.ListStore( str,)
		m.clear()
		for i in api.getQualite():
			m.append( [i,] )
		self.cb_quality.set_model(m)
		self.cb_quality.set_active( self.Prefs.Preferences_get_quality_actif() )

		# maj de la destination
		self.e_dest.set_text( self.Prefs.Preferences_get_dest() )

		# maj de la list des enregistrements prevus
		self.combo_tv_list = self.tv_list
		column = Gtk.TreeViewColumn(_("Chaine"), Gtk.CellRendererText(),text=1,foreground=6)
		self.tv_list.append_column(column)
		column = Gtk.TreeViewColumn(_("Date"), Gtk.CellRendererText(),text=2,foreground=6)
		self.tv_list.append_column(column)
		column = Gtk.TreeViewColumn(_("Debut"), Gtk.CellRendererText(),text=3,foreground=6)
		self.tv_list.append_column(column)
		column = Gtk.TreeViewColumn(_("Fin"), Gtk.CellRendererText(),text=4,foreground=6)
		self.tv_list.append_column(column)

		renderer = Gtk.CellRendererToggle();
		# renderer.set_data("column", 7)
		renderer.connect("toggled", self.on_item_toggled)
		column = Gtk.TreeViewColumn("Shutdown", renderer, active=7, )
		column.set_clickable(True)
		self.tv_list.append_column(column)
		# 0:code, 1:chaine,2:date,3:heure,4:fin,5:fileId,6:color,7:isHalt
		m = Gtk.ListStore( str,str,str,str,str,str,str,bool)
		self.tv_list.set_model(m)
		self.fillAt()

		# timoeut refresh
		self.timer = GObject.timeout_add (3000, self.refresh)

		if not api.isAtdRunning():
			messagebox.show(
				_("Attention "),
				_("Le demon ATD ne semble pas tourner sur votre ordinateur, par consequent fricorder ne sera pas utilisable."),
				yes_callback_function=Gtk.main_quit)

		self.wind_main.show_all()

	def refresh(self):
		self.fillAt()
		return True

	def fillAt(self):
		treeselection = self.tv_list.get_selection()
		if treeselection:
			m, iter0 = treeselection.get_selected()
			path = iter0 and m.get_path(iter0) or None

			m=self.tv_list.get_model()
			m.clear()
			for code,chaine,deb,duree in api.getAtList():

				date = common.affDate(deb)
				heure = deb.strftime("%H:%M")
				fin = (deb+datetime.timedelta(minutes=duree)).strftime("%H:%M")
				fileId = api.FileId.make(chaine,deb,duree)
				file=api.FileId.genPidFileName(fileId)

				if os.path.isfile(file):
					color="red"
				else:
					color="black"

				isHalt = api.FileId.isHaltFileName(fileId)
				# 0:code, 1:chaine,2:date,3:heure,4:fin,5:fileId,6:color,7:isHalt
				m.append( [code,chaine,date,heure,fin,fileId,color,isHalt] )

			if path:
				treeselection.select_path(path)

	def on_imagemenuitem_help_activate(self, widget, data=None):
		wind_about(form=self)

	def on_imagemenuitem_quit_activate(self, widget, data=None):
		self.main_save_preferences()
		Gtk.main_quit()

	def on_item_toggled(self, cell, path_str):
		model = self.tv_list.get_model()
		iter = model.get_iter_from_string(path_str)
		api.FileId.toggleHaltFileName( model.get_value(iter, 5) )
		self.fillAt()

	def main_save_preferences(self):
		print('main_save_preferences')
		x, y = self.wind_main.get_position()
		width, height = self.wind_main.get_size()
		self.Prefs.Preferences_save_op(self.e_dest, self.cb_chaine, self.cb_jour, self.cb_quality, self.sb_time, x, y, width, height)

	def on_wind_main_destroy_event(self, widget, data=None):
		self.main_save_preferences()
		Gtk.main_quit()

	def on_wind_main_delete_event(self, widget, data=None):
		 self.main_save_preferences()
		 Gtk.main_quit()

	def on_btn_supprimer_clicked(self, widget, data=None):

		self._ = _

		treeselection = self.tv_list.get_selection()
		model, iter0 = treeselection.get_selected()
		if not iter0:
			messagebox.show(
				_("Attention "),
				_("Vous devez selectionner au moins\nun enregistrement."))
		else:
			code= model.get_value(iter0,0)
			fileid= model.get_value(iter0,5)
			api.cancelJob(code,fileid)
			self.fillAt()

	def on_btn_quitter_clicked(self, widget, data=None):
		self.main_save_preferences()
		Gtk.main_quit()

	def on_tv_list_button_release_event(self, widget, data=None):
		print('on_tv_list_button_release_event')

	#================================================================
	# ajouter un enregistrement
	#================================================================
	def on_btn_valid_clicked(self, widget, data=None):

		self._ = _

		idx = self.cb_chaine.get_active_iter()
		if not idx:
			 messagebox.show(
				_("Attention "),
				_("Vous devez selectionner une chaine"))
		else:
			model   = self.cb_chaine.get_model()
			chaine  = model.get_value(idx,1)
			stream  = model.get_value(idx,2)
			quality = self.get_text_in_combo(self.cb_quality)

			destination = self.e_dest.get_text()
			if not os.path.isdir(destination):
				 messagebox.show(
					_("Attention "),
					_("Le repertoire de destination n'existe pas"))
			else:
				debut = datetime.datetime(self.date.year,self.date.month,self.date.day,int(self.sb_heure.get_value()),int(self.sb_min.get_value()),0)
				debut= debut+datetime.timedelta(days=self.cb_jour.get_active())
				duree = int(self.sb_time.get_text())

				#print('stream      = ' + stream)
				#print('chaine      = ' + chaine)
				#print('quality     = ' + quality)
				#print('debut       = ', debut)
				#print('duree       = ', duree)
				#print('destination = ' + destination)

				err = api.runAt(stream,chaine,quality,debut,duree,destination)
				if not err:
					time.sleep(1)
					self.fillAt()
				else:
					messagebox.show(
						_("Attention "),
						err)
					self.fillAt()

	def on_btn_dest_clicked(self, widget, data=None):
		wind_chooser(form=self)

	def on_prog_changed(self, widget, data=None):
		idx = self.cb_chaine.get_active_iter()
		if idx:
			model = self.cb_chaine.get_model()
			chaineTV = model.get_value(idx,3)
			chaineTV = self.get_text_in_combo(widget)
			date = self.date + datetime.timedelta( days = self.cb_jour.get_active() )

	def on_sb_time_changed(self, widget, data=None):
		newval = widget.get_text()
		if newval:
			debut = datetime.datetime(self.date.year,self.date.month,self.date.day,int(self.sb_heure.get_value()),int(self.sb_min.get_value()),0)
			debut+=datetime.timedelta(minutes=int(newval))
			self.e_fin.set_text( debut.strftime("%H h %M mn") )

	def on_debut_changed(self, widget, data=None):
		self.on_sb_time_changed(self.sb_time)

	#================================================================
	# get text from combobox
	#   self.combo_tv_list = self.tv_list
	#   self.combo_cb_chaine = self.cb_chaine
	#   self.combo_cb_quality = self.cb_quality
	#================================================================
	def get_text_in_combo(self, combo):
		tree_iter = combo.get_active_iter()
		if tree_iter != None:
			model = combo.get_model()
			print('Selected: ',model[tree_iter][0])
			return model[tree_iter][0]
		else:
			return None

if __name__ == '__main__':
	windows_main = wind_main()
